// DMM750Dlg.h : Header-Datei
//

#if !defined(AFX_DMM750DLG_H__4E798EA5_BD67_11D8_8219_C6219D56380C__INCLUDED_)
#define AFX_DMM750DLG_H__4E798EA5_BD67_11D8_8219_C6219D56380C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DisplayDlg.h"

/////////////////////////////////////////////////////////////////////////////
// Defines
#define MAX_BYTES_NBR 3328 // Anzahl der Bytes einer Druckerausgabe des DMM

/////////////////////////////////////////////////////////////////////////////
// Threadfunktion fuer Empfang der Druckerdaten
long WINAPI ComWatchFct(LPVOID);

class CSettingsDlg;

/////////////////////////////////////////////////////////////////////////////
// CDMM750Dlg Dialogfeld

class CDMM750Dlg : public CDialog
{
private:
  CString m_sCfgFile;
// Konstruktion
public:
	CDMM750Dlg(CWnd* pParent = NULL);	// Standard-Konstruktor

// Dialogfelddaten
	//{{AFX_DATA(CDMM750Dlg)
	enum { IDD = IDD_DMM750_DIALOG };
		// HINWEIS: der Klassenassistent fgt an dieser Stelle Datenelemente (Members) ein
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CDMM750Dlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
public:
  bool GetDataFromFile(CString& _roFileName);
  bool GetDataFromBuffer(void);
  bool ConvertPrinterData2Pixels(void);
  bool SaveBitmapInFile(CString& _roFileName);
  void DrawFrame(void);
  void SaveSettings(void);

  friend long WINAPI ComWatchFct(LPVOID);
  friend CSettingsDlg;

  CBitmap m_bmpBitmap;
  BITMAP m_bm;
 
  CBitmap m_bmoAmpel;
  BITMAP m_bmAmpel;

protected:
	HICON m_hIcon;
  CDisplayDlg m_dlgDisplay;
  unsigned char m_ucaPrinterLines[20][160];
  unsigned char m_ucaPixels[20*160];

  // Konfigurationswerte
  CString m_sCOMPort; // eingestellter COM-Port
  bool m_bFrame;  // TRUE: mit Rahmen

  // Empfang der Druckerdaten
  HANDLE m_hCOM; // Handle des COM Port
  DCB m_oDCB; // Device Control Block
  HANDLE m_hThread; // Handle des Empfangs thread
  DWORD m_dwThreadID;

	// Generierte Message-Map-Funktionen
	//{{AFX_MSG(CDMM750Dlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonshow();
	afx_msg void OnButtonsave();
	afx_msg void OnButtonreceive();
	afx_msg void OnButtonsettings();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_DMM750DLG_H__4E798EA5_BD67_11D8_8219_C6219D56380C__INCLUDED_)
